

get_times <- function(fcst.type, leadtimes, sdate) {

  ## TODO: Adapt to Auto-S2S recipe format
  ## TODO: Is all of this necessary? Is some of it already computed by 
  ## dates2load?
  # fcst.type <- recipe$Analysis$Horizon
  switch(tolower(fcst.type),
	 ## TODO: Remove "sub_obs"?
         "seasonal" = {len <- length(leadtimes); ref <- 'months since '; 
                       stdname <- paste(strtoi(leadtimes), collapse=", ")},
         "sub_obs" = {len <- 52; ref <- 'week of the year ';
                      stdname <- paste(strtoi(leadtimes), collapse=", ")},
         "subseasonal" = {len <- 4; ref <- 'weeks since ';
                          stdname <- ''}
  ) 

  time <- 1:len
  dim(time) <- length(time)
  #metadata <- list(time = list(standard_name = stdname,
  metadata <- list(time = list(units = paste0(ref, sdate, ' 00:00:00')))
  attr(time, 'variables') <- metadata
  names(dim(time)) <- 'time'
  
  time_step <- 1
  dim(time_step) <- length(time_step)
  metadata <- list(time_step = list(units = paste0(ref, sdate, ' 00:00:00')))
  attr(time_step, 'variables') <- metadata
  names(dim(time_step)) <- 'time_step'

  sdate <- 1:length(sdate)
  dim(sdate) <- length(sdate)
  metadata <- list(sdate = list(standard_name = paste(strtoi(sdate),
						      collapse=", "),
                                units = paste0('Init date')))
  attr(sdate, 'variables') <- metadata
  names(dim(sdate)) <- 'sdate'

  return(list(time_step=time_step, time=time, sdate=sdate))

}

get_latlon <- function(latitude, longitude) {
  ## TODO: Verify if this is needed or if it needs a change now that we are
  ## using s2dv_cube objects
  dim(longitude) <- length(longitude)
  metadata <- list(longitude = list(units = 'degrees_east'))
  attr(longitude, 'variables') <- metadata
  names(dim(longitude)) <- 'longitude'
  
  dim(latitude) <- length(latitude)
  metadata <- list(latitude = list(units = 'degrees_north'))
  attr(latitude, 'variables') <- metadata
  names(dim(latitude)) <- 'latitude'

  return(list(lat=latitude, lon=longitude))

}

save_metrics <- function(variable,
                         skill,
                         fcst.sdate,
                         grid,
                         outfile,
                         monthnames,
                         fcst.type,
                         agg) {
  
  ## TODO: Remove variable as entry parameter

  lalo <- c('longitude', 'latitude')

  ## TODO: Sort out aggregation
  if (tolower(agg) == "global") {
    skill <-  lapply(skill, function(x){
                     Reorder(x[[1]], c(lalo, 'time'))})
  }

  for (i in 1:length(skill)) {

    metric <- names(skill[i])
    if (tolower(agg) == "country"){
      sdname <- paste0(names(metric), " region-aggregated metric")
      dims <- c('Country', 'time')
    } else {
      sdname <- paste0(names(metric), " grid point metric")
      dims <- c(lalo, 'time')
    }
    metadata <- list(name = metric, standard_name = sdname)

    attr(skill[i], 'variables') <- metadata        
    names(dim(skill[[i]])) <- dims 
  }

  times <- get_times(fcst.type, monthnames, fcst.sdate)
  time <- times$time
  time_step <- times$time_step

  if (tolower(agg) == "country") { 
    
    country <- get_countries(grid)
    ArrayToNc(append(country, time, skill, time_step), outfile)

  } else  {

    latlon <- get_latlon(grid$lat, grid$lon)
    vars <- list(latlon$lat, latlon$lon, time)
    vars <- c(vars, skill, list(time_step))
    ArrayToNc(vars, outfile)
  }

}

